package com.woniuxy.p_strategy.e;

/*
	һԭ װ仯ԭ
	ҳӦпҪ仯֮ǶҪЩҪ仯Ĵһ
	
	ĸܼ򵥣ÿģʽľڡеģʽṩһ׷
	áϵͳеĳָı䲻Ӱ֡
	
	ãǰѼӵΪDuckȡʱ!
	
	֪Duckڵfly()quack()ѼӵĲͬı䡣
	ΪҪΪDuckзֿǽǴDuckȡһÿΪ(ͼ1)
	
	ڡԽӿڱ̣ʵֱ̡ԭָ£ ע˵ĽӿָǳʵʵĽӿڣ
	Ƕӿ: FlyBehaviorQuackBehaviorеΪ඼ʵӿе֮һ(ͼ2)
	
*/

interface FlyBehavior {
	void fly();
}

class FlyWithWings implements FlyBehavior {
	@Override
	public void fly() {
		System.out.println("I'm flying!!");
	}
}

class FlyNoWay implements FlyBehavior {
	@Override
	public void fly() {
		System.out.println("I can't fly");
	}
}

class FlyRockedPowered implements FlyBehavior {
	@Override
	public void fly() {
		System.out.println("I'm flying with a rocket!");
	}
}

interface QuackBehavior {
	void quack();
}

class Quack implements QuackBehavior {
	@Override
	public void quack() {
		System.out.println("Quack");
	}
}

class MuteQuack implements QuackBehavior {
	@Override
	public void quack() {
		System.out.println("<< Silence >>");
	}
}

class Squeak implements QuackBehavior {
	@Override
	public void quack() {
		System.out.println("Squeak");
	}
}

abstract class Duck {
	protected FlyBehavior flyBehavior;
	protected QuackBehavior quackBehavior;
	
	public void performQuack() {
		quackBehavior.quack();
	}
	
	public void performFly() {
		flyBehavior.fly();
	}

	public void swim() {
		System.out.println("All ducks float, even wooden duck!");
	}
	
	public abstract void display();

	public void setFlyBehavior(FlyBehavior fb) {
		this.flyBehavior = fb;
	}

	public void setQuackBehavior(QuackBehavior qb) {
		this.quackBehavior = qb;
	}
	
}

class MallardDuck extends Duck {
	
	public MallardDuck() {
		quackBehavior = new Quack();
		flyBehavior = new FlyWithWings();
	}
	
	@Override
	public void display() {
		System.out.println("I'm a real Mallard duck");
	}	
}

class ModelDuck extends Duck {

	public ModelDuck() {
		flyBehavior = new FlyNoWay();	// һʼѼģǲɵ
		quackBehavior = new Quack();	
	}
	
	@Override
	public void display() {
		System.out.println("I'm a model duck");
	}
	
}




// ==============================================================

public class Test {
	public static void main(String[] args) {
		Duck mallard = new MallardDuck();
		
		mallard.performQuack();
		mallard.performFly();
		
		System.out.println("=====================");
		Duck model = new ModelDuck();
		model.performFly();
		model.performQuack();
		model.setFlyBehavior(new FlyRockedPowered());
		model.performFly();
	}
}


// ==============================================

class Tang extends Duck {

	public Tang() {
		flyBehavior = new FlyWithWings();
		quackBehavior = new MuteQuack();
	}
	
	@Override
	public void display() {
		System.out.println("Ѽ");
	}
	
}

// ģʽ:
// 㷨壬ֱװ֮Ի滻ģʽ㷨ı仯ʹ㷨Ŀͻ